#ifndef _sudoku_h
#define _sudoku_h

#include <vector>

using namespace std;

class Sudoku {
public:
	int size;
    vector<vector<int> > cells;

    Sudoku();
    Sudoku(vector<vector<int> > board);
    bool is_solved();
    vector<vector<int> > get_result();
};

class Individual {
public:
    vector<vector<int> > gene;
    double fitness;
    
    Individual();
    Individual(vector<vector<int> > _gene);
    double calculate_fitness();
};

class GA {
private:
    vector<int> flex;
	vector<double> prob;
	vector<int> candidates[81];
    vector<vector<int> > board;
    Individual best_individual;
    vector<Individual> current;
    double best_fitness;
    double mutation_rate, crossover_rate;
    int num_individuals, iterations;
   
public:
    GA();
    GA(vector<vector<int> > _board, int num_population = 1000, int _iterations = 100000);
    void initialize();
    void next_generation();
    void mutate(Individual& par);
    void cross_over(Individual& par1, Individual& par2);
    Sudoku* simulate();
};

Sudoku *solve(Sudoku *sdk);
bool comparator(const Individual& id1, const Individual& id2);

#endif
