#ifndef _sudoku_h
#define _sudoku_h

#include <vector>

using namespace std;

class Sudoku {
public:
	int size;
    vector<vector<int> > cells;

    Sudoku();
    Sudoku(vector<vector<int> > board);
    bool is_solved();
    vector<vector<int> > get_result();
};

/* u: 内部値, v:出力値*/
class Neuron {
public:
	double u, v;

	Neuron();
	Neuron(double _u, double _v);
};

class HopfieldNN {
public:
	int num_neuron, size;
	double T;
	vector<Neuron> neurons;
	vector<bool> mark;
	vector<int> flex;

	HopfieldNN();
	HopfieldNN(vector<vector<int> > board);
	void update(int idx);
	double calc_energy();
	Sudoku* simulate();
};

Sudoku *solve(Sudoku *sdk);
#endif
